function [U,V,W] = wireVortexField_vector(r, M, B_0, X, Y, supMagParams)
%%% Calcule du champ magnétique pour une aimantation sous forme de vortex
% au sein du fil en tout point de l'espace.
% 
%
%
% $Revision: 14 $
% $Author: lenertz $
% $Date: 2015-07-27 18:22:01 +0200 (lun., 27 juil. 2015) $

    B_abs = norm(M);
    % Inverse le sens du vortex si une composante de champ est appliqué selon -z
    if B_0(3) < 0;
        B_abs = -B_abs;
    end
    % fonction de rotation du reférenciel à rajouter
    %angle = atan2(norm(cross([1,0,0],H)),dot([1,0,0],H));
    
    % if x is given as an array an not y or the opposit
    if numel(X) ~= numel(Y); 
        if numel(Y) == 1;
            y = Y;
            Y = X;
            Y(:) = y;
        elseif numel(X) == 1;
            x = X;
            X = Y;
            X(:) = x; 
        end
    end
    
    % initialisation des matrices de champs
    U = X;
    U(:)=0;
    V = U;
    W = U;
    
    % On cherche les positions dans et hors du fil
    position_r = (X.^2 + Y.^2).^(1/2);
    in_position = find(position_r <= r & position_r > 0);
    %out_position = find(position_r > r);
    
    % Dans le fil
    U(in_position) = -B_abs .* Y(in_position) ./ position_r(in_position);
    V(in_position) = B_abs .* X(in_position) ./ position_r(in_position);
    W(in_position) = 0;
    
    % On ajoute le champ appliqué
    U = U + B_0(1);
    V = V + B_0(2);
    W = W + B_0(3);

    
end